unit EnumMenusExpert;

interface

uses
  Sysutils, Classes, ToolsAPI, Menus, Dialogs;

type
  TEnumMenusExpert = class(TNotifierObject, IOTANotifier, IOTAWizard, IOTAMenuWizard)
  public
    procedure Execute;
    function GetIDString: string;
    function GetMenuText: string;
    function GetName: string;
    function GetState: TWizardState;
    procedure Destroyed;
  end;

  procedure Register;

implementation

procedure Register;
begin
  RegisterPackageWizard(TEnumMenusExpert.Create as IOTAMenuWizard);
end;

{ TEnumMenusExpert }

procedure TEnumMenusExpert.Destroyed;
begin
  { Do Nothing }
end;

procedure TEnumMenusExpert.Execute;
var
  NTA: INTAServices;
  i, j: Integer;
  SL: TStringList;
begin
  SL := TStringList.Create;
  try
    NTA := BorlandIDEServices as INTAServices;
    for i := 0 to NTA.MainMenu.Items.Count-1 do
      begin
        SL.Add(Format('[%s]: %s', [NTA.MainMenu.Items[i].Caption, NTA.MainMenu.Items[i].Name]));
        for j := 0 to NTA.MainMenu.Items[i].Count-1 do
          SL.Add(Format('  %s: %s', [NTA.MainMenu.Items[i][j].Caption, NTA.MainMenu.Items[i][j].Name]));
        SL.Add('');
      end;
    ShowMessage(SL.Text);
  finally
    SL.Free;
  end;
end;

function TEnumMenusExpert.GetIDString: string;
begin
  Result := 'EnumMenusExpert';
end;

function TEnumMenusExpert.GetMenuText: string;
begin
  Result := 'Enum Menus...';
end;

function TEnumMenusExpert.GetName: string;
begin
  Result := 'Enum Menus Expert';
end;

function TEnumMenusExpert.GetState: TWizardState;
begin
  Result := [wsEnabled];
end;

initialization

finalization

end.
